# Lovable Message mod
# Message people, whether they are offline or not
# Use !pm [partial username/steam id] [msg]
#Only uses ES 2.0
#inspired by Lobe's PrivateMail

import es, cPickle, usermsg, os.path, popuplib, traceback

# Add each admins Steam ID here, atleast the ones you want to be messaged
admins = []

maniPath = str(es.ServerVar('eventscripts_gamedir')) + '/cfg/mani_admin_plugin/clients.txt' 
# Set to one if you would like to use admins from Mani Admin
useMani = 1

# DO NOT EDIT BELOW HERE

lovepm = es.ServerVar('lovepm_version')
lovepm.set('1.0')
lovepm.makepublic()
info = es.AddonInfo()

info['name']        = "Lovable PM"
info['version']     = "1.0"
info['author']      = "Lovecannon"
info['description'] = "Send messages" 

msgdb = es.getAddonPath('lovablepm') + '/msgs.db'

def load():
	# Register commands
	if not es.exists('saycommand', '!pm'):
		es.regsaycmd('!pm', 'lovablepm/newmsg', 'Creates new message')
	if not es.exists('saycommand', '!pmhelp'):
		es.regsaycmd('!pmhelp', 'lovablepm/help', 'Help me?')
	if not es.exists('saycommand', '!pminbox'):
		es.regsaycmd('!pminbox', 'lovablepm/inbox', 'View your inbox')
	if not es.exists('saycommand', '!pmblock'):
		es.regsaycmd('!pmblock', 'lovablepm/block', 'Block a user')
	if not es.exists('saycommand', '!pmunblock'):
		es.regsaycmd('!pmunblock', 'lovablepm/unblock', 'Unblock a user')
	if not es.exists('saycommand', '!pmadmin'):
		es.regsaycmd('!pmadmin', 'lovablepm/msgAdmin', 'Send a message to an admin') 
	es.msg('#green', 'Lovable PM has loaded!')
	
 
def newmsg():
	#Get userid
	userid = es.getcmduserid()
	# Make sure theres enough arguments
	if es.getargc() >= 2:
		#Get arguments
		args = es.getargs().split(' ')
		receipient = args[0]
		x = 1
		msgcontent = ""
		while(x < len(args)):
			msgcontent = msgcontent + args[x] + " "
			x = x + 1
		
		sendMsg(userid, receipient, msgcontent)
	else:
		es.tell(userid, "Syntax incorrect. Correct syntax: !pm <username/steamid> <msg>") 

def msgAdmin():
	#Get userid
	userid = es.getcmduserid()
	# Make sure theres enough arguments
	if es.getargc() >= 2:
		#Get arguments
		args = es.getargs().split(' ')
		
		x = 0
		msgcontent = ""
		while(x < len(args)):
			msgcontent = msgcontent + args[x] + " "
			x = x + 1
		if useMani == 1:
			getManiAdmins()
		for admin in admins:
			sendMsg(userid, admin, msgcontent)
	else:
		es.tell(userid, "Syntax incorrect. Correct syntax: !pmadmin <msg>") 

def help():
	#Self-explanatory
	userid = es.getcmduserid()
	# Make the help popup
	helppopup = popuplib.create('pmhelp')
	helppopup.addline('   Lovable PM Help')
	helppopup.addline('---------------------------------------------')
	helppopup.addline('To send a message, type in chat !pm')
	helppopup.addline('followed with steamID or partial name of the person')
	helppopup.addline('you want to send the message to,')
	helppopup.addline('followed by the message')
	helppopup.addline('An example of this is below:')
	helppopup.addline('!pm STEAM_0:0:138014 Yo.')
	helppopup.addline('or  !pm lovecannon Yo.')
	helppopup.addline('To send to someone offline, use their steam id')
	helppopup.addline('To unblock and block users from sending you messages')
	helppopup.addline('Use !pmblock and !pmunblock')
	helppopup.addline('To message an admin, type !pmadmin <msg>')
	helppopup.send(userid)
	popuplib.delete('pmhelp')

def inbox():
	userid = es.getcmduserid()
	steamid = es.getplayersteamid(userid)
	messages = loadMsgs()
	if messages.has_key(steamid):
		if messages[steamid].has_key('inbox'):
			inbox = messages[steamid]['inbox']
			if len(inbox) > 0:
				inboxpopup = popuplib.easymenu('inbox',None, dltHandler)
				inboxpopup.settitle("PM Inbox - Select a message to delete")
				for msg in inbox:
					x = inbox.index(msg)
					inboxpopup.addoption(x, msg)
				inboxpopup.send(userid)
				popuplib.delete("inbox")
			else: 
				es.tell(userid, "You have no messages in your inbox!")
		else:
			es.tell(userid, "You have no messages in your inbox!")
	else:
		es.tell(userid, "You have no messages in your inbox!")
			
#def deleteMsg(userid, msgnumber, menuname):
	
def dltHandler(userid, choice, popupname):
	messages = loadMsgs()
	steamid = es.getplayersteamid(userid)
	messages[steamid]['inbox'].pop(choice)
	saveMsgs(messages)
	es.tell(userid, "Message deleted!")

def round_start(ev):
	es.msg("#multi", "#green [#lightgreenLovable PM#green]: Type !pminbox to check your inbox, and !pmhelp for help on how to send messages")

def player_activate(ev):
	userid = ev['userid']
	steamid = es.getplayersteamid(userid)
	if os.path.isfile(msgdb):
		messages = loadMsgs()
		# See if user has any messages at all
		if messages.has_key(steamid):
			if messages[steamid].has_key('inbox'):
				inbox = messages[steamid]['inbox']
				if len(inbox) > 0:
					#Create the popup
					popup = popuplib.create("messages")
					popup.addline("MESSAGE!")
					popup.addline("----------")
					popup.addline("You have new messages!")
					popup.addline("Type !pminbox to see your messages!")
					popup.send(userid)
					popuplib.delete("messages")

def loadMsgs():
	if os.path.isfile(msgdb):
		# Load DB if exists
		db = open(msgdb)
		# Load message pickle
		messages = cPickle.load(db)
		# What do you think this does? 
		db.close()
		return messages
	else:
		return {}

def saveMsgs(messages):
	db1 = open(msgdb, 'w')
	cPickle.dump(messages, db1)
	#Dump the data into the file and save the file
	db1.close()
	
def block():
	#Get userid
	userid = es.getcmduserid()
	steamid = es.getplayersteamid(userid) 
	# Make sure theres enough arguments
	if es.getargc() >= 2:
		#Get arguments
		args = es.getargs().split(' ')
		blockee = args[0]
		messages = loadMsgs()
		blockid = es.getuserid(blockee)
		if blockid != 0:
			blockee = es.getplayersteamid(blockid)
			if messages.has_key(steamid):
				if messages[steamid].has_key('blocks'):
					blocks = messages[steamid]['blocks']
					try:
						blocks.index(blockee)
						es.tell(userid, "User is already blocked")
					except:
						blocks.append(blockee)
						messages[steamid]['blocks'] = blocks
						es.tell(userid, "User blocked")
			else:
				blocks = []
				messages[steamid] = {}
				blocks.append(blockee)
				messages[steamid]['blocks'] = blocks
				es.tell(userid, "User blocked")
			saveMsgs(messages)
		else:
			if args[0].startswith('STEAM_0:'):
				if messages.has_key(steamid):
					if messages[steamid].has_key('blocks'):
						blocks = messages[steamid]['blocks']
						try:
							blocks.index(blockee)
							es.tell(userid, "User is already blocked")
						except:
							blocks.append(blockee)
							messages[steamid]['blocks'] = blocks
							es.tell(userid, "User blocked")
				else:
					blocks = []
					blocks.append(blockee)
					messages[steamid] = {}
					messages[steamid]['blocks'] = blocks
					es.tell(userid, "User blocked")
				saveMsgs(messages)
			else:
				es.tell(userid, "The username you have specified is not online, try their steam ID")
	else:
		es.tell(userid, "Syntax incorrect. Correct syntax is !pmblock <partial username or steamid>")

def unblock():
	#Get userid
	userid = es.getcmduserid()
	steamid = es.getplayersteamid(userid) 
	# Make sure theres enough arguments
	if es.getargc() >= 2:
		#Get arguments
		args = es.getargs().split(' ')
		blockee = args[0]
		messages = loadMsgs()
		blockid = es.getuserid(blockee)
		if blockid != 0:
			blockee = es.getplayersteamid(blockid)
			if messages.has_key(steamid):
				if messages[steamid].has_key('blocks'):
					blocks = messages[steamid]['blocks']
					try:
						blocks.remove(blockee)
						messages[steamid]['blocks'] = blocks
						saveMsgs(messages)
						es.tell(userid, "User unblocked")
					except:
						es.tell(userid, "User was not blocked in the first place")
				else:
					es.tell(userid, "User was not blocked in the first place")
			else:
				es.tell(userid, "User was not blocked in the first place")
		else:
			if args[0].startswith('STEAM_0:'):
				if messages.has_key(steamid):
					if messages[steamid].has_key('blocks'):
						blocks = messages[steamid]['blocks']
						try:
							blocks.remove(blockee)
							messages[steamid]['blocks'] = blocks
							saveMsgs(messages)
							es.tell(userid, "User unblocked")
						except:
							es.tell(userid, "User was not blocked in the first place")
					else:
						es.tell(userid, "User was not blocked in the first place")
				else:
					es.tell(userid, "User was not blocked in the first place")
			else:
				es.tell(userid, "The username you have specified is not online, try their steam ID")
	else:
		es.tell(userid, "Syntax incorrect. Correct syntax is !pmunblock <partial username or steamid>")
	
def checkBlock(steamid1, steamid2):
		messages = loadMsgs()
		if messages.has_key(steamid1):
			if messages[steamid1].has_key('blocks'):
				blocks = messages[steamid1]['blocks']
				try:
					blocks.index(steamid2)
					return True
				except:
					es.tell(es.getuserid(steamid2), "Hey")
					return False

def sendMsg(userid, receipient, msgcontent):
	getname = es.getplayername(userid) 
	receipientid = es.getuserid(receipient)
	# See if user is online
	messages = loadMsgs()
	msgcontent = msgcontent.strip()
	if msgcontent != "":
		if receipientid != 0:
			if checkBlock(es.getplayersteamid(receipientid), es.getplayersteamid(userid)):
				es.tell(userid, "You are blocked from sending this user a message")
			else:
				#Message is being sent
				es.tell(userid, "Message sent successfully")
				msgpop = popuplib.create("newmsg")
				msgpop.addline("Lovable PM\n -----------------------\n\nNew message from: %s\n%s\n" % (getname, msgcontent))
				msgpop.send(receipientid)
				popuplib.delete("newmsg")
				es.tell (receipientid, "You have received a new message!")
		else:
			# Okay they are offline, see if the uesr inputted a steam id
			if receipient.startswith('STEAM_0:'):
				# Yes they did, so start the procedure to save the message into the database
				inbox = []
				try:
					if checkBlock(receipient, es.getplayersteamid(userid)):
						es.tell(userid, "You are blocked from sending this user a messsage")
					else:
						# Create dictionary with necessary info
						steamid = receipient
						if messages.has_key(steamid):
							if messages[steamid].has_key('inbox'):
								inbox = messages[steamid]['inbox']
								#key = {"msg": msgcontent, "from": getname, "to": receipient}
								inbox.append(getname + " says: " + msgcontent)
								messages[steamid]['inbox'] = inbox
							else:
								inbox.append(getname + " says: " + msgcontent)
								messages[steamid]['inbox'] = inbox
						else:
							messages[steamid] = {}
							inbox.append(getname + " says: " + msgcontent)
							messages[steamid]['inbox'] = inbox
						saveMsgs(messages)
						es.tell(userid, "Message successfully sent")	
				except: 
					#usermsg.echo(userid, traceback.format_exc())
					es.tell(userid, "Message failed to send")
			else: 
				es.tell(userid, "The user you have specified is not on the server")
	else:
		es.tell(userid, "The message cannot be empty")
def unload():
	if es.exists('saycommand', '!pm'):
		es.unregsaycmd('!pm')
	if es.exists('saycommand', '!pmhelp'):
		es.unregsaycmd('!pmhelp')
	if es.exists('saycommand', '!pminbox'):
		es.unregsaycmd('!pminbox')
	if es.exists('saycommand', '!pmblock'):
		es.unregsaycmd('!pmblock')
	if es.exists('saycommand', '!pmunblock'):
		es.unregsaycmd('!pmunblock')
	if es.exists('saycommand', '!pmadmin'):
		es.unregsaycmd('!pmadmin')
	es.msg('#green', 'Lovable PM has unloaded!')
	
def getManiAdmins(): 
    # Read the clients.txt and append steamids to the list 
    clients = open(maniPath, 'r') 
    
    for line in clients: 
        list_line = line.split('"') 
        if len(list_line) > 3: 
            if list_line[3].startswith('STEAM_'): 
                admins.append(list_line[3]) 
    clients.flush() 
    clients.close() 